unit UMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
      ap_Controls,
    ap_Dialogs,
    ap_Classes,
    ap_DateUtils,
    ap_IniFiles,
    ap_Math,
    ap_StrUtils,
    ap_System,
    ap_SysUtils,
    ap_Graphics,
    ap_Forms,
    ap_StdCtrls,
    ap_Types,
    ap_Variants,
    ap_Windows,
    ap_Buttons;

type
  TForm1 = class(TForm)
    RunButton: TButton;
    EditButton: TButton;
    procedure RunButtonClick(Sender: TObject);
    procedure EditButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
    UScriptIDE,
    IDEMain,
    atScripter;

{$R *.dfm}

procedure TForm1.RunButtonClick(Sender: TObject);
var
  AUnit: TIDEProjectFile;
  TempEngine : TIDEEngine;
  TempScripter : TIDEScripter;
begin
  TempEngine := TIDEEngine.Create(Application);
  TempScripter := TIDEScripter.Create(Application);
  TempEngine.Scripter := TempScripter;
  TempEngine.DlgCloseAll;
  TempEngine.NewProject;
  TempEngine.ProjectName := 'Test Project';

  AUnit := TempEngine.NewUnit(slPascal);
  TempEngine.MainUnit := AUnit;
  AUnit.UnitName := 'Unit1';
  AUnit.Script.SourceCode.Text := 'uses '+
                                  '  Classes, Graphics, Controls, Forms, Dialogs, Unit2; '+
                                  ' '+
                                  'var '+
                                  '  MainForm: TForm2; '+
                                  'begin '+
                                  '  MainForm := TForm2.Create(Application); '+
                                  '  MainForm.Show; '+
                                  'end;';
  TempEngine.UpdateIDE(AUnit);

  AUnit := TempEngine.NewFormUnit(slPascal);
  AUnit.LoadFormFromString('object Form2: TScriptForm '+
                           ' Caption = ''Form2'' '+
                           ' ClientHeight = 356 '+
                           ' ClientWidth = 448 '+
                           ' Color = clBtnFace '+
                           ' Font.Charset = DEFAULT_CHARSET '+
                           ' Font.Color = clWindowText '+
                           ' Font.Height = -11 '+
                           ' Font.Name = ''Tahoma'' '+
                           ' Font.Style = [] '+
                           ' OldCreateOrder = False '+
                           ' Position = poDesigned '+
                           ' SaveProps.Strings = ( '+
                           '   ''Visible=False'') '+
                           ' SaveEvents.Strings = ( '+
                           '   ''Self.OnShow=Form2Show'') '+
                           ' PixelsPerInch = 96 '+
                           ' TextHeight = 13 '+
                          'end ');
  AUnit.UnitName := 'Unit2';
  AUnit.Script.SourceCode.Text := '{$FORM TForm2, Unit2.sfm} '+
                           ' '+
                           '   uses '+
                           '     Classes, Graphics, Controls, Forms, Dialogs, StdCtrls; '+
                           ' '+
                           '   procedure Form2Show(Sender: TObject); '+
                           '   begin '+
                           '     showmessage(''hello world''); '+
                           '   end; '+
                           ' '+
                           ' '+
                           '   begin '+
                           '   end; ';

  TempEngine.UpdateIDE(AUnit);
  TempEngine.RunProject;
end;

procedure TForm1.EditButtonClick(Sender: TObject);
var
  Form : TFScriptIDE;
begin
  Form := TFScriptIDE.Create(nil);
  try
    Form.ShowModal;
  finally
    Form.Free;
  end;
end;

end.
