unit UScriptIDE;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, IDEMain,
  InspectorControls, ComponentInspector, ScrMemo, Vcl.ComCtrls, atScript,
  atScripter, ap_Classes, ap_Graphics, ap_Controls, ap_Forms, ap_Dialogs,
  ap_StdCtrls,
  Vcl.ExtCtrls, Data.DB, adsdata, adsfunc, adstable, adscnnct,
  System.Actions, Vcl.ActnList, Vcl.Mask, vcl.Wwdbedit, vcl.Wwdotdot,
  vcl.Wwdbcomb, Vcl.Menus, atScriptDebug, ScriptCtrls, Vcl.CategoryButtons, dIDEActions;

type
  TFScriptIDE = class(TForm)
    TabControl1: TTabControl;
    IDEMemo1: TIDEMemo;
    IDEEngine1: TIDEEngine;
    IDEScripter1: TIDEScripter;
    IDEFormDesignControl1: TIDEFormDesignControl;
    Splitter1: TSplitter;
    Panel2: TPanel;
    IDEInspector1: TIDEInspector;
    ObjectInspectorComboBox: TwwDBComboBox;
    atScriptDebugger1: TatScriptDebugger;
    Panel1: TPanel;
    IDEComponentComboBox1: TIDEComponentComboBox;
    IDEPaletteButtons1: TIDEPaletteButtons;
    Splitter2: TSplitter;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

//var
//  FIDE: TFIDE;

implementation

{$R *.dfm}

procedure TFScriptIDE.FormClose(Sender: TObject; var Action: TCloseAction);
var
  I: Integer;
begin
  for I := 0 to IDEEngine1.Files.Count - 1 do
  begin
    if IDEEngine1.Files[i].IsForm then
      Continue
    else
    begin
      IDEEngine1.ActiveFile := IDEEngine1.Files[i];
      Break;
    end;
  end;
end;

procedure TFScriptIDE.FormShow(Sender: TObject);
var
  ProjectFile : TIDEProjectFile;
begin
  IDEEngine1.DlgCloseAll;
  IDEEngine1.NewProject;
  IDEEngine1.ProjectName := 'TestProject';

  //has form = false
  ProjectFile := IDEEngine1.NewUnit(slPascal);
  IDEEngine1.MainUnit := ProjectFile;
  ProjectFile.UnitName := 'Unit1';
  ProjectFile.Script.SourceCode.Text := 'uses '+
                                  '  Classes, Graphics, Controls, Forms, Dialogs, Unit2; '+
                                  ' '+
                                  'var '+
                                  '  MainForm: TForm2; '+
                                  'begin '+
                                  '  MainForm := TForm2.Create(Application); '+
                                  '  MainForm.Show; '+
                                  'end;';
  IDEEngine1.UpdateIDE(ProjectFile);

  //has form = true
  ProjectFile := IDEEngine1.NewFormUnit(slPascal);
  ProjectFile.LoadFormFromString('object Form2: TScriptForm '+
                           ' Caption = ''Form2'' '+
                           ' ClientHeight = 356 '+
                           ' ClientWidth = 448 '+
                           ' Color = clBtnFace '+
                           ' Font.Charset = DEFAULT_CHARSET '+
                           ' Font.Color = clWindowText '+
                           ' Font.Height = -11 '+
                           ' Font.Name = ''Tahoma'' '+
                           ' Font.Style = [] '+
                           ' OldCreateOrder = False '+
                           ' Position = poDesigned '+
                           ' SaveProps.Strings = ( '+
                           '   ''Visible=False'') '+
                           ' SaveEvents.Strings = ( '+
                           '   ''Self.OnShow=Form2Show'') '+
                           ' PixelsPerInch = 96 '+
                           ' TextHeight = 13 '+
                          'end ');
  ProjectFile.UnitName := 'Unit2';
  ProjectFile.Script.SourceCode.Text := '{$FORM TForm2, Unit2.sfm} '+
                           ' '+
                           '   uses '+
                           '     Classes, Graphics, Controls, Forms, Dialogs, StdCtrls; '+
                           ' '+
                           '   procedure Form2Show(Sender: TObject); '+
                           '   begin '+
                           '     showmessage(''hello world''); '+
                           '   end; '+
                           ' '+
                           ' '+
                           '   begin '+
                           '   end; ';
  IDEEngine1.UpdateIDE(ProjectFile);
end;

end.
